{*******************************************************}
{ Matrix                                                }
{ ,٥ȥ,ϢΩ켡ȤΥ֥  }
{ version 0.3                                           }
{ CopyRight: Yoshikazu Takamura                         }
{*******************************************************}

unit Matrix;

interface

uses
  SysUtils;

type
  { TMatrix
      
    constructor Create(ARows,ACols:Integer);
      ARowsAColsι.
      ʬ0ǽ.
      ARows0ʲΤȤ,1AColsι.
      ACols0ʲΤȤ,ARows1ι.
    property Component[row,col:Integer]:Double;
      rowcolܤʬ
      row,col,ؤȰۤʤ0Ϥޤ.
      row,colϰϳˤȤ,ERangeErrorȯ.
    property CountofRows:Integer;
      ιԿ
      ɼ
    property CountofColumns:Integer;
      
      ɼ
    function Multiply(Scaler:Double):TMatrix;
      ʬScalerܤ֤.
    function Add(AMatrix:TMatrix):TMatrix;
      ʬAMatrix¤֤.
      ʬAMatrix礭㤦,nil֤.
    function Multiply(AMatrix:TMatrix):TMatrix;
      ʬAMatrix(ʬ*AMatrix)֤.
      ʬAMatrixʤȤ,nil֤. }
  TMatrix=class(TObject)
  private
    Fm:array of array of Double;
    FRows,FCols:Integer;
    procedure SetComponent(row,col:Integer;value:Double);
    function GetComponent(row,col:Integer):Double;
  public
    constructor Create(ARows,ACols:Integer);
    property Component[row,col:Integer]:Double read GetComponent
      write SetComponent;
    property CountofRows:Integer read FRows;
    property CountofColumns:Integer read FCols;
    function Multiply(Scaler:Double):TMatrix;overload;
    function Add(AMatrix:TMatrix):TMatrix;
    function Multiply(AMatrix:TMatrix):TMatrix;overload;
  end;

  { TSquareMatrix
      
      TMatrixѾ
    constructor Create(ASize:Integer);
      AsizeASizeι.
      ʬ0ǽ.
      ASize0,11֤.
    function InverseMatrix:TSquareMatrix;
      ʬεչ֤.
      ʬ§Ǥʤ,nil֤. }
  TSquareMatrix=class(TMatrix)
  public
    constructor Create(ASize:Integer);
    function InverseMatrix:TSquareMatrix;
  end;

  { TVector
      ٥ȥ
    constructor Create(ASize:Integer);
      AsizeοʬΥ٥ȥ.
      ٥ȥʬ0ǽ.
      ASize0ʲΤȤ,ʬ1ĤΥ٥ȥ.
    property Component[sub:Integer]:Double;
      ٥ȥsubܤʬʬ
      sub,ؤȰۤʤ0Ϥޤ.
      sub٥ȥϰϳˤȤ,ERangeErrorȯ.
    property CountofComponent:Integer;
      ٥ȥʬο
      ɼ
    function RowVector:TMatrix;
      ʬԥ٥ȥηˤTMatrix֤.
    function ColumnVector:TMatrix;
      ʬ٥ȥηˤTMatrix֤. }
  TVector=class(TObject)
  private
    Fv:array of Double;
    FSize:Integer;
    procedure SetComponent(sub:Integer;value:Double);
    function GetComponent(sub:Integer):Double;
  public
    constructor Create(ASize:Integer);
    property Component[sub:Integer]:Double read GetComponent write SetComponent;
    property CountofComponent:Integer read FSize;
    function RowVector:TMatrix;
    function ColumnVector:TMatrix;
  end;

  { TSimEquations
      ϢΩ켡
    constructor Create(AOrder:Integer);
      AOrderϢΩ켡.
      ,٥ȥʬ0ǽ.
      AOrder0ʲΤȤ,1ϢΩ.
    property Coefficient:TMatrix;
      
      ɼ
    property Constant:TVector;
      ٥ȥ
      ɼ
    property Order:Integer;
      ο
      ɼ
    function Solution:TVector;
      ϢΩ켡򤤤ƲTVector֤.
      򤬲򤱤ʤ(§ǤʤȤ),nil֤. }
  TSimultaneousEquations=class(TObject)
  private
    FCoefficient:TMatrix;
    FConstant:TVector;
    FOrder:Integer;
  public
    destructor Destroy;override;
    constructor Create(AOrder:Integer);
    property Coefficient:TMatrix read FCoefficient;
    property Constant:TVector read FConstant;
    property Order:Integer read FOrder;
    function Solution:TVector;
  end;

  { function RowElementaryOperation(AMatrix:TMatrix):Boolean;
      AMatrixԴѷ.
      δؿгʬʳʬ0ȤѷԤ,
      гʬ1ȤʤΤ.
      гʬ0ȤʤäƤޤä,ʾԴѷǤʤȤFalse,
      ǸޤǹԴѷǤȤTrue֤.
    procedure MakeColStandardUnitVector(AMatrix:TMatrix;ACol,APosition:Integer;
      AMatrixФ,AColܤAPositionܤǤ1,
      ΤۤǤ0ȤԴѷԤ. }
  function RowElementaryOperation(AMatrix:TMatrix):Boolean;
  procedure MakeColStandardUnitVector(AMatrix:TMatrix;ACol,APosition:Integer);

implementation

const
  EM_RangeErrorMatrix='ʬ[%d,%d]ϹϰϳǤ.';
  EM_RangeErrorVector='ʬ[%d]ϥ٥ȥϰϳǤ.';

constructor TMatrix.Create(ARows,ACols:Integer);
var
  i,j:Integer;
begin
  if ARows>0 then
    FRows:=ARows
  else
    FRows:=1;
  if ACols>0 then
    FCols:=ACols
  else
    FCols:=1;
  SetLength(Fm,FRows,FCols);
  { Fmν }
  for i:=0 to FRows-1 do
  begin
    for j:=0 to FCols-1 do
    begin
      Fm[i,j]:=0;
    end;
  end;
end;

procedure TMatrix.SetComponent(row,col:Integer;value:Double);
begin
  if (0<=row) and (row<FRows) and (0<=col) and (col<FCols) then
    Fm[row,col]:=value
  else
    raise ERangeError.CreateFmt(EM_RangeErrorMatrix,[row,col]);
end;

function TMatrix.GetComponent(row,col:Integer):Double;
begin
  if (0<=row) and (row<FRows) and (0<=col) and (col<FCols) then
    Result:=Fm[row,col]
  else
    raise ERangeError.CreateFmt(EM_RangeErrorMatrix,[row,col]);
end;

function TMatrix.Multiply(Scaler:Double):TMatrix;
var
  i,j:Integer;
begin
  Result:=TMatrix.Create(Self.FRows,Self.FCols);
  for i:=0 to Self.FRows-1 do
  begin
    for j:=0 to Self.FCols-1 do
    begin
      Result.Fm[i,j]:=Self.Fm[i,j]*Scaler;
    end;
  end;
end;

function TMatrix.Add(AMatrix:TMatrix):TMatrix;
var
  i,j:Integer;
begin
  if (Self.FRows=AMatrix.FRows) and (Self.FCols=AMatrix.FCols)then
  begin
    Result:=TMatrix.Create(Self.FRows,Self.FCols);
    for i:=0 to Self.FRows-1 do
    begin
      for j:=0 to Self.FCols-1 do
      begin
        Result.Fm[i,j]:=Self.Fm[i,j]+AMatrix.Fm[i,j];
      end;
    end
  end
  else
  begin
    Result:=nil;
  end;
end;

function TMatrix.Multiply(AMatrix:TMatrix):TMatrix;
var
  i,j,k:Integer;
  S:Double;
begin
  if Self.FCols=AMatrix.FRows then
  begin
    Result:=TMatrix.Create(Self.FRows,AMatrix.FCols);
    for i:=0 to Self.FRows-1 do
    begin
      for j:=0 to AMatrix.FCols-1 do
      begin
        S:=0;
        for k:=0 to Self.FCols-1 do
        begin
          S:=S+Self.Fm[i,k]*AMatrix.Fm[k,j]
        end;
        Result.Fm[i,j]:=S;
      end;
    end;
  end
  else
  begin
    Result:=nil;
  end;
end;

constructor TSquareMatrix.Create(ASize:Integer);
begin
  inherited Create(ASize,ASize);
end;

function TSquareMatrix.InverseMatrix:TSquareMatrix;
var
  m:TMatrix;
  i,j:Integer;
begin
  { mγ }
  m:=TMatrix.Create(Self.FRows,Self.FCols*2);
  try
    for i:=0 to Self.FRows-1 do
    begin
      for j:=0 to Self.FCols*2-1 do
      begin
        if j<Self.FCols then
          m.Fm[i,j]:=Self.Fm[i,j]
        else if j-Self.FCols=i then
          m.Fm[i,j]:=1
        else
          m.Fm[i,j]:=0;
      end;
    end;
    { Դѷ }
    if RowElementaryOperation(m) then
    begin
      { չκ }
      Result:=TSquareMatrix.Create(Self.FRows);
      for i:=0 to Self.FRows-1 do
      begin
        for j:=0 to Self.FCols-1 do
        begin
          Result.Fm[i,j]:=m.Fm[i,j+Self.FCols]/m.Fm[i,i];
        end;
      end;
    end
    else
    begin
      { §Ǥʤ }
      Result:=nil;
      Exit;
    end;
  finally
    m.Free;
  end;
end;

constructor TVector.Create(ASize:Integer);
var
  i:Integer;
begin
  if ASize>0 then
    FSize:=ASize
  else
    FSize:=1;
  SetLength(Fv,FSize);
  for i:=0 to FSize-1 do
  begin
    Fv[i]:=0;
  end;
end;

procedure TVector.SetComponent(sub:Integer;value:Double);
begin
  if (0<=sub) and (sub<FSize) then
    Fv[sub]:=value
  else
    raise ERangeError.CreateFmt(EM_RangeErrorVector,[sub]);
end;

function TVector.GetComponent(sub:Integer):Double;
begin
  if (0<=sub) and (sub<FSize) then
    Result:=Fv[sub]
  else
    raise ERangeError.CreateFmt(EM_RangeErrorVector,[sub]);
end;

function TVector.RowVector:TMatrix;
var
  i:Integer;
begin
  Result:=TMatrix.Create(1,Self.FSize);
  for i:=0 to Self.FSize-1 do
  begin
    Result.Fm[0,i]:=Self.Fv[i];
  end;
end;

function TVector.ColumnVector:TMatrix;
var
  i:Integer;
begin
  Result:=TMatrix.Create(Self.FSize,1);
  for i:=0 to Self.FSize-1 do
  begin
    Result.Fm[i,0]:=Self.Fv[i];
  end;
end;

constructor TSimultaneousEquations.Create(AOrder:Integer);
var
  i,j:Integer;
begin
  if AOrder>0 then
    FOrder:=AOrder
  else
    FOrder:=1;
  Self.FCoefficient:=TMatrix.Create(Self.FOrder,Self.FOrder);
  Self.FConstant   :=TVector.Create(Self.FOrder);
end;

destructor TSimultaneousEquations.Destroy;
begin
  Self.FCoefficient.Free;
  Self.FCoefficient:=nil;
  Self.FConstant.Free;
  Self.FConstant:=nil;
end;

function TSimultaneousEquations.Solution:TVector;
var
  max,c:Double;
  max_i,i,j,k:Integer;
  m:TMatrix;
begin
  { mγ }
  m:=TMatrix.Create(Self.FOrder,Self.FOrder+1);
  try
    for i:=0 to FOrder-1 do
    begin
      for j:=0 to FOrder-1 do
      begin
        m.Fm[i,j]:=Self.FCoefficient.Fm[i,j];
      end;
      m.Fm[i,Self.FOrder]:=Self.FConstant.Fv[i];
    end;
    { Դѷ }
    if RowElementaryOperation(m) then
    begin
      { §ξ }
      { Υ٥ȥκ }
      Result:=TVector.Create(Self.FOrder);
      for i:=0 to Self.FOrder-1 do
      begin
        Result.Fv[i]:=m.Fm[i,Self.FOrder]/m.Fm[i,i];
      end;
    end
    else
    begin
      { §Ǥʤ }
      Result:=nil;
    end;
  finally
    m.Free;
    m:=nil;
  end;
end;

{ AMatrixԴѷ }
function RowElementaryOperation(AMatrix:TMatrix):Boolean;
var
  max,c:Double;
  max_i,i,j,k:Integer;
begin
  { AMatrixгǰʳξõ }
  for i:=0 to AMatrix.FRows-1 do
  begin
    { i򲼲Ȥߤ }
    if i >= AMatrix.FCols then Exit;
    { iκͤ }
    max_i:=i;
    max:=abs(AMatrix.Fm[i,i]);
    { i,i겼ǤФ }
    if i < AMatrix.FRows-1 then
    begin
      for j:=i+1 to AMatrix.FRows-1 do
      begin
        if max < abs(AMatrix.Fm[j,i]) then
        begin
          max:=abs(AMatrix.Fm[j,i]);
          max_i:=j;
        end;
      end;
    end;
    { ͤ0ΤȤ,Ĥޤ그§ǤʤȤν }
    if max=0 then
    begin
      Result:=False;
      Exit;
    end;
    { ͤͭԤiԤ촹 }
    if max_i<>i then
    begin
      for j:=0 to AMatrix.FCols-1 do
      begin
        c:=AMatrix.Fm[max_i,j];
        AMatrix.Fm[max_i,j]:=AMatrix.Fm[i,j];
        AMatrix.Fm[i,j]:=c;
      end;
    end;
    { i,iʳõ }
    for j:=0 to Amatrix.FRows-1 do
    begin
      { iϽʤ }
      if j=i then continue;
      c:=AMatrix.Fm[j,i];
      { AMatrix.Fm[j,i]=0ʤ,ʤ }
      if c=0 then continue;
      { i꺸νѤϽʤ }
      for k:=i to AMatrix.FCols-1 do
      begin
        if k=i then
          AMatrix.Fm[j,k]:=0
        else
          AMatrix.Fm[j,k]:=AMatrix.Fm[j,k]-c*AMatrix.Fm[i,k]/AMatrix.Fm[i,i]
      end;
    end;
  end;
  Result:=True;
end;

{ AMatrixФ,AColܤAPositionܤǤ1,ΤۤǤ0ȤԴѷԤ }
procedure MakeColStandardUnitVector(AMatrix:TMatrix;ACol,APosition:Integer);
var
  i,j:Integer; { i:,j: }
begin
  with AMatrix do
  begin
    if Fm[APosition,ACol]<>0 then
    begin
      { AColܤAPositionܤǤ0Ǥʤ }
      for j:=0 to FCols-1 do
      begin
        { APositionܤι }
        if j <> ACol then
        begin
          { AColܰʳ }
          Fm[APosition,j]:=Fm[APosition,j]/Fm[APosition,ACol];
        end;
      end;
      for i:=0 to FRows-1 do
      begin
        for j:=0 to FCols-1 do
        begin
          if i <> APosition then
          begin
            { APositionܤι԰ʳ }
            if j <> ACol then
            begin
              { AColܰʳ }
              Fm[i,j]:=Fm[i,j]-Fm[APosition,j]*Fm[i,ACol];
            end;
          end;
        end;
      end;
      for i:=0 to FRows-1 do
      begin
        { AColܤ }
        if i = APosition then
        begin
          { APositionܤ }
          Fm[i,ACol]:=1;
        end
        else
        begin
          { APositionܰʳ }
          Fm[i,ACol]:=0;
        end;
      end;
    end;
  end;
end;

end.
